### Eclipse Workspace Patch 1.0
#P ODK Collect
Index: src/org/odk/collect/android/activities/FormEntryActivity.java
===================================================================
--- src/org/odk/collect/android/activities/FormEntryActivity.java	(revision 723)
+++ src/org/odk/collect/android/activities/FormEntryActivity.java	(working copy)
@@ -111,6 +111,8 @@
 
     // uncomment when ProgressBar slowdown is fixed.
     // private ProgressBar mProgressBar;
+    
+    private static int swipeCounter;
 
     private String mFormPath;
     private String mInstancePath;
@@ -530,11 +532,13 @@
                 case SWIPE_RIGHT:
                     mBeenSwiped = true;
                     showPreviousView();
-                    handled = true;
+                    trackSwipeCount();
+                    handled = true;	
                     break;
                 case SWIPE_LEFT:
                     mBeenSwiped = true;
                     showNextView();
+                    trackSwipeCount();
                     handled = true;
                     break;
             }
@@ -543,6 +547,16 @@
     }
 
 
+	private void trackSwipeCount() {
+		swipeCounter++;
+		if (swipeCounter == 3) {
+			swipeCounter = 0;
+			executeSaveToDiskTask(false, false);
+			dismissDialog(SAVING_DIALOG);
+		}
+	}
+
+
     /**
      * Determines what should be displayed on the screen. Possible options are: a question, an ask
      * repeat dialog, or the submit screen. Also saves answers to the data model after checking
@@ -817,7 +831,12 @@
             return false;
         }
 
-        mSaveToDiskTask = new SaveToDiskTask();
+        return executeSaveToDiskTask(exit, complete);
+    }
+
+
+	private boolean executeSaveToDiskTask(boolean exit, boolean complete) {
+		mSaveToDiskTask = new SaveToDiskTask();
         mSaveToDiskTask.setFormSavedListener(this);
 
         // TODO remove completion option from db
@@ -829,7 +848,7 @@
         showDialog(SAVING_DIALOG);
 
         return true;
-    }
+	}
 
 
     private void createQuitDialog() {
@@ -1063,7 +1082,10 @@
      */
     @Override
     protected void onPause() {
+    	//we want to save the form any time the user starts another activity for example camera, hits home button etc
+    	saveDataToDisk(false, false);
         dismissDialogs();
+        dismissDialog(SAVING_DIALOG);
         super.onPause();
     }
 
